<?PHP
/**

  @author Nicholas Avenell <nicholas@aquarionics.com>
  @desc   Screenpop Test - Experience Points

  1. Create a function that produces the level of a user based on how
  many experience points they have earned. Initially a user requires ten
  experience points to reach the next level. Every ten levels, five
  additional experience points are required to reach the next level. For
  example, a user would need 100 experience points to reach level 10,
  250 experience points to reach level 20, and 450 experience points to
  reach level 30. Your function should handle error situations
  gracefully. Please deliver your function in an easily testable way.

*/

include("panic.inc.php"); // Nice error function

define("LEVELLING_INCREASE_AMOUNT", 5);
define("LEVELLING_INCREASE_LEVELS", 10);
define("LEVELLING_INITIAL_BOUNDRY", 10);



function xp($score){
  
  if(!is_numeric($score)){
    throw Exception("Current score is invalid");
  }
  
  $level = 1;
  $points_per_level = LEVELLING_INITIAL_BOUNDRY;
  $next_level_boundry = $points_per_level;
  
  while ($score > $next_level_boundry){
    $level++;
    if($level % LEVELLING_INCREASE_LEVELS == 0){
      $points_per_level += LEVELLING_INCREASE_AMOUNT;
    }
    $next_level_boundry += $points_per_level;
  }
  
  return $level;
  
}

$tests = array(
  0 => 1,
  100 => 10,
  250 => 20,
  450 => 30,
  1000 => 50
);

echo "<h2>TESTS</h2>
<pre>
";

foreach ($tests as $points => $level){
  $result = xp($points);
  $success = $result == $level ? "SUCCESS!" : "FAILURE :-(";
  
  printf("% 4d points should be L% 3d, Result % 4d, %s\n", $points, $level, $result, $success);
  
}

?></pre>